#This makes a 2 state FSA.  It does it without calling any of the 
#FSA functions. State 0, turns on state 1, but both remain on, and sends
#1 some extra activation to make it go at 4 ms.

from nealCoverClass import NealCoverFunctions
import pyNN.spiNNaker as sim
import numpy as np

from stateMachineClass import FSAHelperFunctions

#---Below here are functions to test the system---
RUN_DURATION = 200
#initialize the simulator. 
def init():
    sim.setup(timestep=neal.DELAY,min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)

def printPklSpikes(fileName):
    fileHandle = open(fileName)
    neoObj = pickle.load(fileHandle)
    segments = neoObj.segments
    segment = segments[0]
    spikeTrains = segment.spiketrains
    neurons = len(spikeTrains)
    for neuronNum in range (0,neurons):
        if (len(spikeTrains[neuronNum])>0):
            spikes = spikeTrains[neuronNum]
            for spike in range (0,len(spikes)):
                print neuronNum, spikes[spike]
    fileHandle.close()
    

def createOneInput():
    inputSpikeTimes0 = [10.0]
    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
                                   label='inputSpikes_0')

    return spikeGen0


def createNeurons():
    numNeurons = fsa.CA_SIZE * 2
    cells=sim.Population(numNeurons,sim.IF_cond_exp,fsa.CELL_PARAMS)
    return cells

#This is the spinn7 way to record.  You need the record_v to print
#volts.
def setupRecording(cells):
    cells.record()
    cells.record_v()

def printResults(simCells):
    if  (neal.simulator == 'nest'):
        simCells.printSpikes('temp.pkl')
        #printPklSpikes('temp.pkl')
    elif (neal.simulator == 'spinnaker'):
        simCells.printSpikes('temp.sp')
        simCells.print_v('temp.volts')

##--main---
simName = "spinnaker"
spinnVersion = 7
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
init()
firstSpikeGenerator =  createOneInput()

stateCells = createNeurons()

setupRecording(stateCells)
 
#Build the FSA
fsa.turnOnStateFromSpikeSource(firstSpikeGenerator,stateCells,0)
fsa.makeCA(stateCells,0)
fsa.makeCA(stateCells,1)
fsa.stateTurnsOnStateSlow(stateCells,0,stateCells,1)
fsa.stateStimulatesState(stateCells,0,stateCells,1,0.004)

neal.nealApplyProjections()
sim.run(RUN_DURATION)

printResults(stateCells)
