#This builds and test a two state FSA.  It calls the test functions
#in the FSAClass.  It should have the same results as testFSA.py.
#state 0 and input 1 turns on state 2.  2 turns off 1 and 0.

from nealCoverClass import NealCoverFunctions
import pyNN.spiNNaker as sim

import cPickle as pickle
import numpy as np

from stateMachineClass import FSAHelperFunctions

#---Below here are functions to test the system---
RUN_DURATION = 200

##--main---
simName = "spinnaker"
spinnVersion = 7
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)

fsa.testInit()

#setup input
spikeGenerators = fsa.testCreateTwoInputs()
firstSpikeGenerator =  spikeGenerators[0]
secondSpikeGenerator =  spikeGenerators[1]

#make neurons and make them recordable
stateCells = fsa.testCreateNeurons()
fsa.testSetupRecording(stateCells)

#build the fsa and run it
fsa.test3StateFSA(firstSpikeGenerator,secondSpikeGenerator,stateCells)
neal.nealApplyProjections()
fsa.testRunFSA(RUN_DURATION)

#print results
fsa.testPrintResults(stateCells)



