#This makes 1 state and accesses it via one neuron.  First the neuron
#is turned on which turns the state on, then 


from nealCoverClass import NealCoverFunctions
import pyNN.spiNNaker as sim

import cPickle as pickle
import numpy as np

from stateMachineClass import FSAHelperFunctions

#---Below here are functions to test the system---
RUN_DURATION = 300
#initialize the simulator. 
def init():
    sim.setup(timestep=neal.DELAY,min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)


def printPklSpikes(fileName):
    fileHandle = open(fileName)
    neoObj = pickle.load(fileHandle)
    segments = neoObj.segments
    segment = segments[0]
    spikeTrains = segment.spiketrains
    neurons = len(spikeTrains)
    for neuronNum in range (0,neurons):
        if (len(spikeTrains[neuronNum])>0):
            spikes = spikeTrains[neuronNum]
            for spike in range (0,len(spikes)):
                print neuronNum, spikes[spike]
    fileHandle.close()
    

def createFourInputs():
    inputSpikeTimes0 = [10.0]
    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
                                   label='inputSpikes_0')

    inputSpikeTimes1 = [100.0]
    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
    spikeGen1=sim.Population(1,sim.SpikeSourceArray,spikeArray1,
                                   label='inputSpikes_1')

    inputSpikeTimes2 = [150.0]
    spikeArray2 = {'spike_times': [inputSpikeTimes2]}
    spikeGen2=sim.Population(1,sim.SpikeSourceArray,spikeArray2,
                                   label='inputSpikes_2')

    inputSpikeTimes3 = [200.0]
    spikeArray3 = {'spike_times': [inputSpikeTimes3]}
    spikeGen3=sim.Population(1,sim.SpikeSourceArray,spikeArray3,
                                   label='inputSpikes_3')

    return [spikeGen0,spikeGen1,spikeGen2,spikeGen3]


def createNeurons():
    numNeurons = fsa.CA_SIZE * 2
    cells=sim.Population(numNeurons,sim.IF_cond_exp,fsa.CELL_PARAMS)
    return cells

def setupRecording(cells):
    cells.record({'spikes','v'})

def printResults(simCells):
    simCells.printSpikes('temp.sp')

def spikeSourceFiresNeuron(spikeSource,cells,neuronNumber):
    connector = [(0,neuronNumber,fsa.INPUT_WEIGHT,neal.DELAY)]
    neal.nealProjection(spikeSource,cells, connector,'excitatory')


##--main---
simName = "spinnaker"
spinnVersion = 7
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
init()
spikeGenerators =  createFourInputs()

stateCells = createNeurons()

setupRecording(stateCells)

#make a state
fsa.makeCA(stateCells,0)

#play with the state using spike sources
spikeSourceFiresNeuron(spikeGenerators[0],stateCells,10)
spikeSourceFiresNeuron(spikeGenerators[1],stateCells,11)
spikeSourceFiresNeuron(spikeGenerators[2],stateCells,12)
spikeSourceFiresNeuron(spikeGenerators[3],stateCells,13)
fsa.oneNeuronTurnsOnState(stateCells,10,stateCells,0)
fsa.oneNeuronStimulatesState(stateCells,11,stateCells,0,0.1)
fsa.oneNeuronInhibitsState(stateCells,12,stateCells,0,-0.2)
fsa.oneNeuronTurnsOffState(stateCells,13,stateCells,0)

neal.nealApplyProjections()
sim.run(RUN_DURATION)

printResults(stateCells)
