#This makes a 2 state FSA.  It does it without calling any of the 
#FSA test functions. State 0, turns on state 1, but both remain on.
#This uses stateTurnsOnStateSlow; the idea is that the post state doesn't
#run hot.  Both hould persist at 5ms.

from nealCoverClass import NealCoverFunctions
import pyNN.spiNNaker as sim

import cPickle as pickle
import numpy as np

from stateMachineClass import FSAHelperFunctions

#---Below here are functions to test the system---
RUN_DURATION = 200
#initialize the simulator. 
def init():
    sim.setup(timestep=neal.DELAY,min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)

def printPklSpikes(fileName):
    fileHandle = open(fileName)
    neoObj = pickle.load(fileHandle)
    segments = neoObj.segments
    segment = segments[0]
    spikeTrains = segment.spiketrains
    neurons = len(spikeTrains)
    for neuronNum in range (0,neurons):
        if (len(spikeTrains[neuronNum])>0):
            spikes = spikeTrains[neuronNum]
            for spike in range (0,len(spikes)):
                print neuronNum, spikes[spike]
    fileHandle.close()
    

def createOneInput():
    inputSpikeTimes0 = [10.0]
    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
                                   label='inputSpikes_0')

    return spikeGen0

def createNeurons():
    numNeurons = fsa.CA_SIZE * 2
    cells=sim.Population(numNeurons,sim.IF_cond_exp,fsa.CELL_PARAMS)
    return cells

def setupRecording(cells):
    if  ((neal.simulator == 'nest') or 
         ((neal.simulator == 'spinnaker') and (neal.spinnVersion == 8))):
        cells.record({'spikes','v'})
    elif ((neal.simulator == 'spinnaker') and (neal.spinnVersion == 7)):
        cells.record()
        cells.record_v()

def printResults(simCells):
    if  ((neal.simulator == 'nest') or 
         ((neal.simulator == 'spinnaker') and (neal.spinnVersion == 8))):
        simCells.printSpikes('temp.pkl')
    elif ((neal.simulator == 'spinnaker') and (neal.spinnVersion == 7)):
        simCells.printSpikes('temp.sp')
        #simCells.print_v('temp.volts')

##--main---
simName = "spinnaker"
spinnVersion = 8
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
init()
firstSpikeGenerator =  createOneInput()

stateCells = createNeurons()

setupRecording(stateCells)

#Build the FSA
fsa.turnOnStateFromSpikeSource(firstSpikeGenerator,stateCells,0)
fsa.makeCA(stateCells,0)
fsa.makeCA(stateCells,1)
fsa.stateTurnsOnStateSlow(stateCells,0,stateCells,1)

neal.nealApplyProjections()
sim.run(RUN_DURATION)

printResults(stateCells)



